<?php
/*
*-------------------------------phpMyBitTorrent--------------------------------*
*--- The Ultimate BitTorrent Tracker and BMS (Bittorrent Management System) ---*
*--------------   Created By Antonio Anzivino (aka DJ Echelon)   --------------*
*-------------               http://www.p2pmania.it               -------------*
*----------         Developed By Emad Hossam (aka emadness)          ----------*
*-------------               http://www.fulldls.com               -------------*
*------------ Based on the Bit Torrent Protocol made by Bram Cohen ------------*
*-------------              http://www.bittorrent.com             -------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*--   This program is free software; you can redistribute it and/or modify   --*
*--   it under the terms of the GNU General Public License as published by   --*
*--   the Free Software Foundation; either version 2 of the License, or      --*
*--   (at your option) any later version.                                    --*
*--                                                                          --*
*--   This program is distributed in the hope that it will be useful,        --*
*--   but WITHOUT ANY WARRANTY; without even the implied warranty of         --*
*--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          --*
*--   GNU General Public License for more details.                           --*
*--                                                                          --*
*--   You should have received a copy of the GNU General Public License      --*
*--   along with this program; if not, write to the Free Software            --*
*-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA --*
                                                                             --*
*------------------------------------------------------------------------------*
*------              2005 phpMyBitTorrent Development Team              ------*
*-----------               http://phpmybittorrent.com               -----------*
*------------------------------------------------------------------------------*
*/

require_once("include/config.php");
require_once("language/mailtexts.php");

$phpver = phpversion();
if ($phpver < '4.1.0') {
    $_GET = $HTTP_GET_VARS;
    $_POST = $HTTP_POST_VARS;
    $_SERVER = $HTTP_SERVER_VARS;
}
if ($phpver >= '4.0.4pl1' AND eregi("compatible",$_SERVER["HTTP_USER_AGENT"])) {
        if (extension_loaded('zlib')) {
                ob_end_clean();
                ob_start('ob_gzhandler');

        }
} elseif ($phpver > '4.0') {
        if (eregi("gzip",$_SERVER["HTTP_ACCEPT_ENCODING"])) {
                if (extension_loaded('zlib')) {
                        //$do_gzip_compress = TRUE;
                        ob_start("ob_gzhandler");
                        ob_implicit_flush(0);
                        header('Content-Encoding: gzip');
                }

        }

} else {
        ob_start();
}

function hash_where($name, $hash) {
    $shhash = preg_replace('/ *$/s', "", $hash);
    return "($name = '" . escape($hash) . "' OR $name = '" . escape($shhash) . "')";
}
function err($msg) {
        benc_resp(array("failure reason" => array(type => "string", value => $msg)));
        exit();
}

function benc_resp($d) {
        benc_resp_raw(benc(array(type => "dictionary", value => $d)));
}
function hash_pad($hash) {
    return str_pad($hash, 20);
}
function benc_resp_raw($x) {
        header("Content-Type: text/plain");
        header("Pragma: no-cache");
        echo $x;
}

$req = "info_hash:peer_id:!ip:port:uploaded:downloaded:left:!event";
foreach (explode(":", $req) as $x) {
        if ($x[0] == "!") {
                $x = substr($x, 1);
                $opt = 1;
        }
        else
                $opt = 0;
        if (!isset($$x)) {
                if (!$opt)
                        err("missing key");
                continue;
        }
        $$x = unesc($$x);
}

foreach (array("info_hash","peer_id") as $x) {
        if (strlen($$x) != 20)
                err("invalid $x (" . strlen($$x) . " - " . urlencode($$x) . ")");
}

if (empty($ip) OR !preg_match('/^(\d{1,3}\.){3}\d{1,3}$/s', $ip))
        $ip = $_SERVER["REMOTE_ADDR"];

$user_sql = "SELECT id FROM torrent_users WHERE lastip = '".ip2long($ip)."' ORDER BY lastlogin DESC LIMIT 1;";
if (! $userres = $db->sql_query($user_sql)) err("SQL Error: ".$user_sql);
if ($userrow = $db->sql_fetchrow($userres)) {
        $uid = $userrow["id"];
} else {
        $uid = 0;
}
$db->sql_freeresult($userres);

if ($announce_level == "user" AND $uid == 0) err("Only registered users are allowed to use our tracker");

$port = intval($port);
$downloaded = intval($downloaded);
$uploaded = intval($uploaded);
$left = intval($left);

$rsize = 50;
foreach(array("num want", "numwant", "num_want") as $k) {
        if (isset($$k)) {
                $rsize = intval($$k);
                break;
        }
}

if (!$port || $port > 0xffff)
        err("invalid port");

if (!isset($event))
        $event = "";

$seeder = ($left == 0) ? "yes" : "no";

$sql_select = "SELECT id, name, banned, name FROM torrent_torrents WHERE " . hash_where("info_hash", urldecode($info_hash));
if(! $res = $db->sql_query($sql_select) ) err("SQL Error = $sql_select");

if (! $torrent = $db->sql_fetchrow($res) ) err("Torrent not registered with this tracker.");
$db->sql_freeresult($res);
$torrentid = $torrent["id"];
$torrentname = $torrent["name"];

$fields = "seeder, peer_id, ip, port, uploaded, downloaded, upload_speed, UNIX_TIMESTAMP(SYSDATE())  - UNIX_TIMESTAMP(last_action) as seconds";


$sql_select = "SELECT $fields FROM torrent_peers WHERE torrent = '".$torrentid."' ORDER BY RAND() LIMIT $rsize";
if(! $res = $db->sql_query($sql_select) ) err("SQL Error = $sql_select");

$resp = "d" . benc_str("interval") . "i" . $announce_interval . "e" . benc_str("peers") . "l";
unset($self);
while ($row = $db->sql_fetchrow($res)) {
        $row["peer_id"] = hash_pad($row["peer_id"]);

        if ($row["peer_id"] === $peer_id) {
                $self = $row;
                continue;
        }

        $resp .= "d" .
                benc_str("ip") . benc_str($row["ip"]) .
                benc_str("peer id") . benc_str($row["peer_id"]) .
                benc_str("port") . "i" . $row["port"] . "e" .
                "e";
}
$db->sql_freeresult($res);

$resp .= "ee";
$selfwhere = "torrent = '".$torrentid."' AND " . hash_where("peer_id", $peer_id);

if (!isset($self)) {
        $sql_select = "SELECT $fields FROM torrent_peers WHERE $selfwhere";
        if(! $res = $db->sql_query($sql_select) ) err("Error ".$sql_select);
        if ($row = $db->sql_fetchrow($res)) $self = $row;;
        $db->sql_freeresult($res);
}

$updateset = array();

if ($event == "stopped") {
        if (isset($self)) {
                $sql_delete = "DELETE FROM torrent_peers WHERE $selfwhere";
                if(!$db->sql_query($sql_delete)) err("Error ".$sql_delete);
                if ($db->sql_affectedrows() > 0) {
                        if ($self["seeder"] == "yes")
                                $updateset[] = "seeders = seeders - 1";
                        else
                                $updateset[] = "leechers = leechers - 1";
                }
                $updateset[] = "tot_peer = tot_peer - 1";
                $updateset[] = "speed = speed - '".$self["upload_speed"]."'";
        }
} else {
        if ($event == "completed") {
                $updateset[] = "completed = completed + 1";
                $sql_trigger = "SELECT U.email FROM torrent_users U, torrent_seeder_notify S WHERE S.torrent = '".$torrentid."' AND S.user = U.id AND S.status = 'active';";
                if (! $res_trigger = $db->sql_query($sql_trigger)) err("Error SQL = $sql_trigger");
                global $admin_email, $langlevel, $language, $sitename, $siteurl;
                $notify_mail = New eMail();
                $notify_mail->sender = $admin_email;
                $search = Array("**name**","**sitename**","**siteurl**","**torrenturl**","**unwatchurl**");
                $replace = Array($torrentname,$sitename,$siteurl,$siteurl."/details.php?id=".$torrentid,$siteurl."/details.php?id=".$torrentid."&op=seeder&trig=off");
                $notify_mail->subject = str_replace("**sitename**",$sitename,$seedermailsub[$language]);
                $notify_mail->body = str_replace($search,$replace,$seedermailtext[$language]);
                while ($row_trigger = $db->sql_fetchrow($res_trigger)) {
                        $notify_mail->Add($row_trigger["email"]);
                }
                $notify_mail->Send();
                $db->sql_freeresult($res_trigger);
                unset($notify_mail);
                $sql_update = "UPDATE torrent_seeder_notify SET status = 'stopped' WHERE torrent = '".$torrentid."';";
                $db->sql_query($sql_update);
        }

        if (isset($self)) {

                if ($uploaded>=$self["uploaded"] AND $self["seconds"] != 0){
                        $upload_speed = round( ($uploaded - $self["uploaded"]) / $self["seconds"] );
                        $updateset[] = "speed = speed -'".$self["upload_speed"]."' + '$upload_speed'";
                }else{
                        $upload_speed = 0;
                }
                if ($downloaded>=$self["downloaded"] AND $self["seconds"] != 0){
                        $download_speed = round( ($downloaded - $self["downloaded"]) / $self["seconds"] );
                }else{
                        $download_speed=0;
                }

                $sql_update = "UPDATE torrent_peers SET ip = '" . escape($ip) . "', port = '".$port."', uploaded = '".$uploaded."', downloaded = '".$downloaded."', to_go = '".$left."', last_action = NOW(), seeder = '".$seeder."', download_speed='".$download_speed."', upload_speed='".$upload_speed."' WHERE ".$selfwhere.";";
                if(! $db->sql_query($sql_update) ) err("Error ".$sql_update);

                if ($db->sql_affectedrows() > 0 && $self["seeder"] != $seeder) {
                        if ($seeder == "yes") {
                                $updateset[] = "seeders = seeders + 1";
                                $updateset[] = "leechers = leechers - 1";
                        }
                        else {
                                $updateset[] = "seeders = seeders - 1";
                                $updateset[] = "leechers = leechers + 1";
                        }
                }
        }else {
                global $autoscrape;
                $connectable = "yes";
                if ($autoscrape) {
                        $sockres = @fsockopen($ip, $port, $errno, $errstr, 5);
                        if (!$sockres) $connectable = "no";
                        @fclose($sockres);
                }

                if ($seeder=="no") {

                        $sql_trigger = "SELECT count( A.seeder ) AS tot, A.seeder AS seed, A.ip, sum( B.size )  AS tot_size, max(B.size) as max_size, U.level as level FROM torrent_peers A LEFT JOIN torrent_users U ON U.id = '".$uid."', torrent_torrents B WHERE A.ip = '".$ip."' AND A.torrent = B.id GROUP  BY ip, seed order by seed";
                        $res_trigger = $db->sql_query($sql_trigger) or err("SQL Error: $sql_trigger");
                        if ($row_trigger = $db->sql_fetchrow($res_trigger)) {

                                $check_seed=true;                        // false = trigger found
                                $check_leech=true;                        // false = trigger found

                                if ($min_share_seed>0){
                                        if($row_trigger["seed"]=="yes" AND $row_trigger["tot_size"] >= $min_share_seed) {
                                                //if row_trigger["seed"]=="no" check only leech
                                        }else{
                                                $check_seed = false;
                                        }
                                }

                                if ($min_size_seed>0){
                                        if($row_trigger["seed"]=="yes" && $row_trigger["max_size"] >= $min_size_seed) {
                                                //if row_trigger["seed"]=="no" check only leech
                                        }else{
                                                $check_seed = false;
                                        }
                                }

                                if ($row_trigger["seed"]=="yes") $row_trigger = $db->sql_fetchrow($res_trigger);

                                if (!$check_seed && $row_trigger){

                                        if ($max_num_file>0){
                                                if($max_num_file > $row_trigger["tot"]){
                                                } else {
                                                        $check_leech= false;
                                                }
                                        }

                                        if ($max_share_size >0){
                                                if($max_share_size > $row_trigger["tot_size"] ){
                                                } else {
                                                        $check_leech = false;
                                                }
                                        }
                                }

                                if ($check_seed==false AND $check_leech==false AND $row_trigger["level"]=="user") err("You can't download so much. Wait for your uploads to reach minimum limit and try again");
                        }
                        $db->sql_freeresult($res_trigger);
                }


                $sql_insert = "INSERT INTO torrent_peers (connectable, torrent, peer_id, ip, port, uploaded, downloaded, to_go, started, last_action, seeder) VALUES ('$connectable', '$torrentid', '" . escape($peer_id) . "', '" . $ip . "', '".$port."', '".$uploaded."', '".$downloaded."', '".$left."', NOW(), NOW(), '".$seeder."')";

                if ($db->sql_query($sql_insert)) {
                        if ($seeder == "yes")
                                $updateset[] = "seeders = seeders + 1";
                        else
                                $updateset[] = "leechers = leechers + 1";
                        $updateset[] = "tot_peer = tot_peer + 1";
                }
        }
}

if ($seeder == "yes") {
        $updateset[] = "visible = 'yes'";
        $updateset[] = "last_action = NOW()";
}

if (count($updateset)){
        $sql_update = "UPDATE torrent_torrents SET " . implode(",", $updateset) . " WHERE id = '".$torrentid."'";
        $db->sql_query($sql_update) or err("Error SQL = ".$sql_update);
}
if ($uid != 0) {
        $sql = "UPDATE torrent_users SET uploaded = uploaded + ".$uploaded.", downloaded = downloaded + ".$downloaded." WHERE id=".$uid.";";
        $db->sql_query($sql);
}

benc_resp_raw($resp);
ob_end_flush();
die();
?>
