<?php
/*
*-------------------------------phpMyBitTorrent--------------------------------*
*--- The Ultimate BitTorrent Tracker and BMS (Bittorrent Management System) ---*
*--------------   Created By Antonio Anzivino (aka DJ Echelon)   --------------*
*-------------               http://www.p2pmania.it               -------------*
*----------         Developed By Emad Hossam (aka emadness)          ----------*
*-------------               http://www.fulldls.com               -------------*
*------------ Based on the Bit Torrent Protocol made by Bram Cohen ------------*
*-------------              http://www.bittorrent.com             -------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*--   This program is free software; you can redistribute it and/or modify   --*
*--   it under the terms of the GNU General Public License as published by   --*
*--   the Free Software Foundation; either version 2 of the License, or      --*
*--   (at your option) any later version.                                    --*
*--                                                                          --*
*--   This program is distributed in the hope that it will be useful,        --*
*--   but WITHOUT ANY WARRANTY; without even the implied warranty of         --*
*--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          --*
*--   GNU General Public License for more details.                           --*
*--                                                                          --*
*--   You should have received a copy of the GNU General Public License      --*
*--   along with this program; if not, write to the Free Software            --*
*-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA --*
                                                                             --*
*------------------------------------------------------------------------------*
*------              2005 phpMyBitTorrent Development Team              ------*
*-----------               http://phpmybittorrent.com               -----------*
*------------------------------------------------------------------------------*
*/

if (!eregi("upload.php", $_SERVER['PHP_SELF'])) die ("You can't access this file directly...");
if (!is_user($btuser)) loginerror("user");

function print_parse(&$parse_array_read){
        foreach ($parse_array_read as $key => $val){
                echo "[$key => ";
                if (is_array ($val)){
                        echo "<BLOCKQUOTE dir=ltr style='MARGIN-RIGHT: 0px'><P>";
                        print_parse($val);
                        echo "</P></BLOCKQUOTE>";
                }else{
                        echo $val;
                }
                echo "]";
        }
}

function _Sha1toBase32($in){
        $Table = "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567";

        $out = substr($Table, ((ord(substr($in, 0, 1)) >> 3)               ) & 0x1F, 1);
        $out .= substr($Table, ((ord(substr($in, 0, 1)) << 2) | (ord(substr($in, 1, 1)) >> 6)) & 0x1F, 1);
        $out .= substr($Table, ((ord(substr($in, 1, 1)) >> 1)               ) & 0x1F, 1);

        $a = (ord(substr($in, 1, 1)) << 4) & 0x00FF;
        $b = ((ord(substr($in, 2, 1))) >> 4)&0x00FF;
        $out .= substr($Table, ( $a | $b )&0x1F, 1);

        $a = ( (ord(substr($in, 2, 1))&0x00FF) << 1) &0x00FF;
        $b = ((ord(substr($in, 3, 1)) >> 7)) &0x00FF;


        $out .= substr($Table, ( $a | $b )&0x1F, 1);
        $out .= substr($Table, ((ord(substr($in, 3, 1)) >> 2)               ) & 0x1F, 1);

        $a = (ord(substr($in, 3, 1)) << 3) & 0x00FF;
        $b = ((ord(substr($in, 4, 1)) >> 5)) &0x00FF;
        $out .= substr($Table, ( $a|$b ) & 0x1F, 1);

        $out .= substr($Table, ((ord(substr($in, 4, 1))     )               ) & 0x1F, 1);
        return $out;
}

// Return a base32 representation of a sha1 hash
function Sha1toBase32($Sha1){
        //Magnetic link
        $ret="";

        $Base32 = _Sha1toBase32(substr($Sha1, 0, 5));
        $Base32 .= _Sha1toBase32(substr($Sha1, 5, 5));
        $Base32 .= _Sha1toBase32(substr($Sha1, 10, 5));
        $Base32 .= _Sha1toBase32(substr($Sha1, 15, 5));

        $ret = $Base32;
        return $ret;
}

function strtohex($strtmp){
        //Emule
        $max = strlen($strtmp);
        $hex = "";
        for($i=0; $i<$max;$i++){
                $hex .= dechex(ord(substr($strtmp, $i, 1)));
        }
        return strtoupper($hex);
}

ini_set("upload_max_filesize",$max_torrent_size);

$errmsg = Array();

$category = intval($torrent_category);
if ($category < 1) bterror(_btnoselected,_btuploaderror);

$cats = catlist();
$in_cat = false;
while ($cat = each($cats) AND !$in_cat) {
        if ($category == $cat[1]["id"]) $in_cat = true;
}

if (!$in_cat) $errmsg[] = _btillegalcat;

if (!isset($_FILES["filex"]))
        $errmsg[] = _btmissingdata;

$f = $_FILES["filex"];
$fname = unesc($f["name"]);

if (empty($fname))
        $errmsg[] = _btemptyfname;
if (!is_filename($fname))
        $errmsg[] = _btinvalidfname;
if (!preg_match('/^(.+)\.torrent$/si', $fname, $matches))
        $errmsg[] = _btfnamenotorrent;

$nf = $_FILES["nfox"];
$nfname = unesc($nf["name"]);
if ($nfname != "") {
        if (!is_filename($nfname))
                $errmsg[] = _btinvalidnfofname;
        if (!preg_match('/^(.+)\.nfo$/si', $nfname, $matches))
                $errmsg[] = _btfnamenonfo;
        if (!is_uploaded_file($nf["tmp_name"]))
                $errmsg[] = _bterrnonfoupload;
        if ($nf["size"] <= 0)
                $errmsg[] = _btemptyfile;
}

#Return Error
if (count($errmsg) > 0)
        bterror($errmsg,_btupload);

$shortfname = $torrentname = $matches[1];
if (!empty($namex))
        $torrentname = unesc($namex);

$tmpname = $f["tmp_name"];

if (!is_uploaded_file($tmpname))
        $errmsg[] = _bterrnofileupload;
if (!filesize($tmpname))
        $errmsg[] = _btemptyfile;

#Return Error
if (count($errmsg) > 0)
        bterror($errmsg,_btuploaderror);


$uploader_host = gethostbyaddr($_SERVER["REMOTE_ADDR"]); //uploader's hostname
$pagetorrent = "";
$fp = fopen($tmpname,"rb");
while (!feof($fp)) {
        $pagetorrent.=fread($fp,1000);
}
fclose($fp);
$torrent = bdec($pagetorrent);
unset($pagetorrent);

list($announce, $info) = dict_check($torrent, "announce(string):info");


list($dname, $plen, $pieces) = dict_check($info, "name(string):piece length(integer):pieces(string)");
if (strlen($pieces) % 20 != 0)
        bterror(_btinvpieces,_btuploaderror);


if (dict_exists($torrent,"comment(string)")) list ($tcomment) = dict_check($torrent,"comment(string)");
else $tcomment = "";

if ($tcomment == "" AND !isset($descr)) bterror(_btdescrrequired,_btuploaderror);
if (!get_magic_quotes_gpc()) $descr = unesc($descr);
if ($descr == "") $descr = parsedescr($tcomment);

$annregexp = "/(http[s]?+):\/\/[-\/.:_\\w]*\/announce[^\/\\s]*/";
if (!preg_match($annregexp, $announce)) bterror(_btinvannounce."<b>".$announce. "</b>",_btuploaderror);

global $announce_url, $stealthmode;
if ($announce == $announce_url AND $stealthmode) bterror(str_replace("**name**",$sitename,_bttrackerdisabled),_btuploaderror);
elseif ($announce == $announce_url AND !$stealthmode)
        $announce = "";

$totallen = dict_get($info, "length", "integer");

$magnet_link = "";
$ed2k_link = "";

if (isset($totallen)) {
        if(dict_exists($info,"sha1(string)")) {
                list ($sha1code) = dict_check($info, "sha1(string)");
                $magnet_link = "magnet:?xt=urn:sha1:".addslashes(Sha1toBase32($sha1code))."&dn=".$dname;
        } else {
                $magnet_link = "";
        }
        if(dict_exists($info,"ed2k(string)")) {
                list ($ed2k) = dict_check($info, "ed2k(string)");
                $ed2k_link = "ed2k://|file|".$dname."|".$totallen."|".strtohex($ed2k)."|/";
        } else {
                $ed2k_link = "";
        }
        $filelist[] = array($dname, $totallen, $magnet_link, $ed2k_link);
        $type = "single";
} else {
        $flist = dict_get($info, "files", "list");
        if (!isset($flist))
                bterror(_btmissinglength,_btuploaderror);
        if (!count($flist))
                bterror(_btnofilesintorrent,_btuplaoderror);
        $totallen = 0;
        foreach ($flist as $fn) {
                list($ll, $ff) = dict_check($fn, "length(integer):path(list)");
                $totallen += $ll;
                $ffa = array();
                foreach ($ff as $ffe) {
                        if ($ffe["type"] != "string")
                                bterror(_btfilenamerror,_btuploaderror);
                        $ffa[] = $ffe["value"];
                }
                if (!count($ffa))
                        bterror(_btfilenamerror,_btuploaderror);
                $ffe = implode("/", $ffa);

                if(dict_exists($fn,"sha1(string)")) {
                        list ($sha1code) = dict_check($fn,"sha1(string)");
                        $magnet_link = "magnet:?xt=urn:sha1:".addslashes(Sha1toBase32($sha1code))."&dn=".urlencode($ffa[count($ffa)-1]);
                } else {
                        $magnet_link = "";
                }
                if(dict_exists($fn,"ed2k(string)")) {
                        list ($ed2k) = dict_check($fn,"ed2k(string)");
                        $ed2k_link = "ed2k://|file|".urlencode($ffa[count($ffa)-1])."|".$ll."|".strtohex($ed2k)."|/";
                } else {
                        $ed2k_link = "";
                }

                $filelist[] = array($ffe, $ll, $magnet_link, $ed2k_link);
        }
        $type = "multi";
}

$infohash = pack("H*", sha1($info["string"]));

$owner = getuserid($btuser);
$ownertype = intval($ownertype);
if ($ownertype == 2) $owner = 0;
$evidence = intval($evidence);

#Checking against the SAME Torrent
$sql = "SELECT id FROM torrent_torrents WHERE info_hash = '".escape($infohash)."';";
$res = $db->sql_query($sql) or btsqlerror($sql);
if ($db->sql_numrows($res) > 0) {
        list ($id) = $db->sql_fetchrow($res);
        bterror(str_replace("#id#",$id,_bttorrentpresent),_btuploaderror);
}
$db->sql_freeresult($res);

$sql = "SELECT  count(id) as num, sum(size) as tot_size FROM torrent_torrents where added > sysdate() - 1000000 AND owner = '".getuserid($btuser)."'";
$res = $db->sql_query($sql) or bterror($sql);
list ($torrents, $uploaded_size) = $db->sql_fetchrow($res);
$db->sql_freeresult($res);

#Checking against maximum upload size
if (!is_premium($btuser) AND $totallen < $minupload_size_file)
        bteerror(_bttorrenttoosmall1.mksize($minupload_size_file)._bttorrenttoosmall2.mksize($totallen)."</b>.",_btuploaderror);

#Checking against Max num upload on 24h time
if (!is_premium($btuser) && $maxupload_day_num>0 && $maxupload_day_num<=$torrents)
        bterror(str_replace("**maxupload**",$maxupload_day_num,_btmaxuploadexceeded),_btuploaderror);

//Max size share upload on 24h
if (!is_premium($btuser) AND $maxupload_day_share>0 AND $maxupload_day_share < $uploaded_size+$totallen){
        $search = Array("**maxupload**","**rownum**","**totsize**");
        $replace = Array($maxupload_day_share,$torrents,mksize($uploaded_size));
        bterror(str_replace($search,$replace,_btnumfileexceeded),_btuploaderror);
}

#Filename must be at least 4 chars
$materia=trim($fname);
$pos = strrpos($materia, '.');
if (!$pos===false)
        $materia = substr($materia, 0, $pos);
$search = array ("'[^a-zA-Z]'",                 // Remove not lecter
        "'([\r\n])[\s]+'"                 // Remove Blank space
);
$replace = array (
        " ",
        "\\1"
);
$materia = preg_replace ($search, $replace, $materia);
$materia = explode(" ", $materia);

$sql_filter = "";
foreach($materia as $x){
        $x = trim($x);
        if(strlen($x) > 2){
                $sql_filter .= " OR keyword LIKE '".$x."'";
        }
}
$errmsg = "";
$sql_filter = "SELECT * FROM torrent_filter WHERE 1=0 ".$sql_filter.";";
$res = $db->sql_query($sql_filter) or btsqkerror($sql_filter);
if ($db->sql_numrows($res) > 0){
                $errmsg = _btillegalword;
                while ($row = $db->sql_fetchrow($res)){
                        $errmsg.= "<li><b>".$row[keyword]."</b> ".$row[reason];
                }
                $errmsg.= _btillegalwordinfo;
                bterror($errmsg,_btuploaderror);
}
$db->sql_freeresult($res);

#Checking against SIMILAR files

if ($jump_check == 1){
        $materia=trim($fname);
        $pos = strrpos($materia, '.');
        if (!$pos===false)
                $materia = substr($materia, 0, $pos);
        $search = array (
                 "'[^a-zA-Z]'",                 // Remove not lecter
                 "'([\r\n])[\s]+'"                 // Remove Blank space
        );
        $replace = array (
                 " ",
                 "\\1"
        );

        $materia = preg_replace ($search, $replace, $materia);
        $materia=explode(" ", $materia);

        $sql = "";
        $sql_filter = "";
        foreach($materia as $x){
                        $x = trim($x);
                        if(strlen($x)>=5){
                                        $sql .= " OR filename LIKE '".str_replace("\'","\\\'",$x)."'";
                        }
        }
        foreach ($filelist as $file) {
                        $sql .= " OR size = '".$file[1]."'";
        }


        $sql = "SELECT torrent, filename, size FROM torrent_files WHERE 1=0 ".$sql;
        $res = $db->sql_query($sql) or bterror($sql);

        $errmsg = "";
        if ($db->sql_numrows($res) > 0){
                $errmsg = _btsearchdupl;
                while ($row = $db->sql_fetchrow($res)){
                        $errmsg.= "<li><a href='details.php?id=".$row["torrent"]."&hit=1'>".$row["filename"]."</a> (".mksize($row["size"]).")";
                }
                $errmsg.= _btduplinfo;
                bterror($errmsg,_btuploaderror);
        }
}

preg_match_all('/([\\w]{6,}+)/', $descr, $search_descr);
preg_match_all('/([\\w]{6,}+)/', $dname, $search_name);

$searchtext = $shortfname." ".implode(" ",$search_descr[0])." ".implode(" ",$search_name[0]);

if($autoscrape AND $announce != "") {
        /*$peer_id = "-MYBT";
        for ($i = 1; $i <=14; $i++)
                $peer_id.= intval(rand(0,9));
        $peer_id.= "-";
        */
        $tmp_tracker=str_replace("announce", "scrape", $announce)."?info_hash=".urlencode($infohash);

        #Debug 1
        //echo $tmp_tracker."<br>";
        $seeders = $leechers = $tot_peer = 0;
        $scrape = array();
        if ($fp = @fopen($tmp_tracker, "rb")) {
                stream_set_timeout($fp, 10);
                while (!feof($fp)) {
                        $page.= fread($fp,1000000);
                }
                fclose($fp);
                $scrapedata = bdec($page);
                #Debug 2
                //print_parse($scrapedata);
                #Check data
                if (!dict_exists($scrapedata,"files(dictionary)"))
                        bterror(_bttrackerdata,_btscrapeerror);
                else{
                        //check seeder
                        $seeders = intval($scrapedata["value"]["files"]["value"][$infohash]["value"]["complete"]["value"]);
                        if ($seeders<=0) bterror(_btnoseedersontracker,_btscrapeerror);
                        $leechers = intval($scrapedata["value"]["files"]["value"][$infohash]["value"]["incomplete"]["value"]);
                        $completed = intval($scrapedata["value"]["files"]["value"][$infohash]["value"]["downloaded"]["value"]);
                }
        } else {
                bterror(_bttrackernotresponding.$announce,_btscrapeerror);
        }
} else {
                $seeders = 0;
                $leechers = 0;
                $completed = 0;

}
if ($seeders == 0) $visible = "no";
else $visible = "yes";

$torrentfields = "(info_hash, name, filename, save_as, search_text, descr, size, category, type, numfiles, added, views, downloaded, completed, banned, visible, evidence, owner, ownertype, uploader_host, numratings, ratingsum, seeders, leechers, tot_peer, speed, comments, complaints, tracker, tracker_update, last_action)";
if ($announce != "") $torrentvalues = "('".escape($infohash)."', '".escape($torrentname)."', '".escape($dname)."', '".escape($shortfname)."', '".escape($searchtext)."', '".escape(strip_tags($descr))."', '".$totallen."', '".$category."', '".$type."', '".count($filelist)."', NOW(), 0, 0, '".$completed."', 'no', '".$visible."', '".intval($evidence)."', '".intval($owner)."', '".intval($ownertype)."', '".$uploader_host."', '0', '0', '".intval($seeders)."', '".intval($leechers)."', '".intval($seeders+$leechers)."', '0', '0', '0,0', '".$announce."', NOW(), NOW())";
else $torrentvalues = "('".$infohash."', '".escape($torrentname)."', '".escape($dname)."', '".escape($shortfname)."', '".escape($searchtext)."', '".escape($tcomment)."', '".$totallen."', '".$category."', '".$type."', '".count($filelist)."', NOW(), 0, 0, '".$completed."', 'no', '".$visible."', '".intval($evidence)."', '".intval($owner)."', '".intval($ownertype)."', '".$uploader_host."', '0', '0', '".intval($seeders)."', '".intval($leechers)."', '".intval($seeders+$leechers)."', '0', '0', '0,0', NULL, NOW(), NOW())";
$torrentsql = "INSERT INTO torrent_torrents $torrentfields VALUES $torrentvalues;";
$db->sql_query($torrentsql) or btsqlerror($torrentsql);
$id = $db->sql_nextid();
if ($id == 0) bterror("Torrent ID Error",_btuploaderror);

if ($announce != "") $db->sql_query("INSERT INTO torrent_trackers (url, updated) VALUES ('".$announce."', NOW());");
$db->sql_query("DELETE FROM torrent_files WHERE torrent = '$id'") or btsqlerror("DELETE FROM torrent_files WHERE torrent = '$id'");
foreach ($filelist as $file) {
        list ($fname, $fsize, $magnet, $ed2k) = $file;
        $fields = "(torrent, filename, size";
        $values = "('".$id."', '".str_replace("'","\'",$fname)."', '".$fsize."'";
        if ($magnet != "") {
                $fields.= ", magnet";
                $values.= ", '".escape($magnet)."'";
        }
        if ($ed2k != "") {
                $fields.= ", ed2k";
                $values.= ", '".escape($ed2k)."'";
        }
        $fields.= ")";
        $values.= ")";
        $filesql = "INSERT INTO torrent_files $fields VALUES $values;";
        if (!$db->sql_query($filesql)) { //Rollback
                $db->sql_query("DELETE FROM torrent_torrents WHERE id = '".$id."' LIMIT 1;");
                $db->sql_query("DELETE FROM torrent_files WHERE torrent = '".$id."';");
                btsqlerror($filesql);
        }
}
$torrentpath = "$torrent_dir/$id.torrent";
if (file_exists($torrentpath)) unlink($torrentpath);
move_uploaded_file($tmpname,$torrentpath);
$nfopath = "$torrent_dir/$id.nfo";
if (file_exists($nfopath)) unlink($nfopath);
if (!empty($nfname)) move_uploaded_file($nf["tmp_name"],$nfopath);

OpenTable(_btupload);
echo "<meta http-equiv=\"refresh\" content=\"3;url=details.php?id=$id\">";
$search = Array("**name**","**id**");
$replace = Array($name, $id);
echo str_replace($search,$replace,_btuploadcomplete);


if ($commnotify == "ok"){
        $sql = "INSERT INTO torrent_comments_notify (torrent, user) VALUES ('".$id."', ".getuserid($btuser).")";
        $db->sql_query($sql) or btsqlerror($sql);
        echo  "<br>"._btaddnotifycomment;
}
if ($seednotify == "ok" AND $announce == "") {
        $sql = "INSERT INTO torrent_seeder_notify (torrent, user) VALUES ('".$id."', ".getuserid($btuser).")";
        $db->sql_query($sql) or btsqlerror($sql);
        echo "<br>"._btaddnotifyseeder;
}
CloseTable();
?>
